#include <avr/pgmspace.h>
#include <font4x6.h>
#include <TVout.h>
#include <Controllers.h>
#include "pollserial.h"

prog_char t_ver[7] PROGMEM =    "v.0.72";
prog_char t_wait[17] PROGMEM =   "looking for host";
prog_char t_conn[17] PROGMEM =   "connected       ";
prog_char t_update[17] PROGMEM = "updating loader ";
prog_char t_load[17] PROGMEM =   "loading bin file";

unsigned char logo[300] PROGMEM = {
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0x80,0x03,0x80,0xff,0xff,0xe3,0xff,0xff,0xff,0xff,0x1f,0xff,0xff,
0xff,0xc0,0x00,0x07,0x00,0x7d,0xff,0xe3,0xff,0xff,0xff,0xff,0x1f,0xff,0xff,
0xff,0x00,0x00,0x07,0x01,0xe1,0xff,0xe3,0xff,0xff,0xff,0xff,0x1f,0xff,0xff,
0xfe,0x00,0x0f,0xff,0x87,0x8f,0x9f,0xc7,0xfc,0x3f,0x03,0xe0,0x3e,0x1e,0x27,
0xfe,0x07,0xff,0xff,0xfe,0x78,0x07,0xc7,0xf0,0x1e,0x01,0xc0,0x38,0x0e,0x07,
0xfe,0x01,0xff,0xff,0xff,0x00,0x03,0xc7,0xf1,0x8c,0x71,0x86,0x39,0xc6,0x1f,
0xfe,0x00,0x7f,0xff,0xff,0x00,0x03,0xc7,0xe3,0x8f,0xc1,0x8e,0x30,0x06,0x3f,
0xff,0x00,0x07,0xff,0xff,0x00,0x01,0xc7,0xe3,0x8e,0x01,0x8e,0x30,0x06,0x3f,
0xff,0xc0,0x01,0xff,0xfe,0x00,0x01,0xc7,0xe3,0x8c,0x31,0x8e,0x31,0xfe,0x3f,
0xff,0xf0,0x00,0xff,0xf8,0x00,0x03,0x8f,0xe3,0x18,0xe3,0x8c,0x71,0x8c,0x7f,
0xff,0xfe,0x00,0x7f,0x00,0x00,0x03,0x80,0x60,0x38,0x03,0x80,0x70,0x1c,0x7f,
0xff,0xff,0x80,0x38,0x00,0x00,0x07,0x80,0x70,0x7c,0x23,0xc4,0x78,0x3c,0x7f,
0xe0,0x7f,0x00,0x38,0x00,0x00,0x1f,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xe0,0x00,0x00,0x70,0x00,0x00,0x3f,0x0c,0xc7,0xb6,0x73,0x6b,0x58,0xb3,0x6f,
0xc0,0x00,0x00,0x70,0x00,0x01,0xff,0x7b,0x5b,0xb5,0xad,0x5b,0x57,0xad,0x2f,
0xc0,0x00,0x00,0xe0,0x00,0x07,0xff,0x1b,0x47,0x84,0x2f,0x3b,0x59,0xad,0x4f,
0xc0,0x00,0x01,0xe0,0x00,0x7f,0xff,0x7b,0x5b,0xb5,0xad,0x5d,0x5e,0xad,0x6f,
0xf0,0x00,0x1f,0xe3,0xff,0xff,0xff,0x7c,0xdb,0xb5,0xb3,0x6e,0x51,0xb3,0x6f,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff
};

TVout TV;
pollserial pserial;

#define MAX_INPUT 15
bool host_ready = false;
void setup ()
{
  TV.begin(_NTSC,120,96);
  TV.select_font(font4x6);
  TV.bitmap(0,0,logo,0,120,20);
  TV.printPGM(94,22,t_ver); 

  TV.printPGM(0,22,t_wait);

  TV.set_hbi_hook(pserial.begin(57600));
  
} 

void process_data (char * data)
  {
   if ( strcmp(data,"host ping!")==0) {
     pserial.println("ready");
     if (!host_ready){
       TV.printPGM(0,22,t_conn);
       host_ready = true;
     }
    }
  }  // end of process_data
  
char input_line[MAX_INPUT];
unsigned char input_pos = 0;
int unsigned cnt = 0;
bool haslist = false;
int list_count = 0;
int g_sel = -1;


bool getLine(long unsigned timeout=2000) {

  input_pos = 0;  
  while ((timeout--)>0){  
  
    if (pserial.available () > 0) 
      {
      char inByte = pserial.read ();
      switch (inByte)
        {
  
        case '\n':   // end of text
          input_line [input_pos] = 0;  // terminating null byte
          input_pos = 0;  
          return true;
          break;
        case '\r': 
          break;
    
        default:
          // keep adding if not full ... allow for terminating null byte
          if (input_pos < (MAX_INPUT - 1))
            input_line [input_pos++] = inByte;
          break;
  
        }  // end of switch
  
    }  // end of incoming data
  delay(1);
  }
  return false;
  
}

void Lclear(){
  TV.draw_rect(0,21,90,75,0,0);
};

void getList(){
  if (getLine()) {
    list_count = atoi(input_line);  
  } 
  Lclear();

  delay(10);
  for(int i=0;i<list_count;i++){
    if (getLine(200)) {
      TV.print(30,(i*8)+24,input_line);   
    }
    delay(5);
  }  
  if (list_count>0) {
    haslist=true;
    g_sel=0;
    drawbar();    
   // TV.set_hbi_hook(nothin);
   // pserial.end();
  };

  char col=0;
  
  for(int i=0;i<25;i+=2){
     TV.draw_column(70+col,30+i,30+49-i,1);
     TV.draw_column(20-col,30+i,30+49-i,1);
 
     col++;
  }

};

void drawbar(){
    TV.draw_rect(25,g_sel*8+22,40,8,0,2);
}

void loop()
{

  if ((cnt++)%3==0) {  
    if (!haslist && host_ready) {
      pserial.println("list");
      getList();
    }
  }

  if (g_sel>-1) {
    if (Controller.leftPressed() && Controller.rightPressed()) {
       Lclear();
       TV.printPGM(0,22,t_update);
       delay(2000);      
       pserial.println("progme");
    };
    if (Controller.upPressed()) {
        drawbar();
        g_sel = (list_count+g_sel-1) % list_count;    
        drawbar();
        delay(500);
    };
    if (Controller.downPressed()) {
        drawbar();
        g_sel = (g_sel+1) % list_count;    
        drawbar();
        delay(500);
    };
    if (Controller.firePressed()) {
       Lclear();
       TV.printPGM(0,22,t_load);
       delay(2000);   
       pserial.print("load");
      pserial.println(g_sel,DEC);
    };
  }

  if (!haslist) {
    if (getLine(300)) {
      process_data(input_line);    
    }
  }
   
  if (!host_ready) {
    pserial.println("ready");
  }
   
  delay(1);
}  // end of loop
